Description

It would be nice if QGIS could use the "system settings" for a proxy server. Firefox and Chrome can both do this, at least on Windows

(never tried them on different OS's with a proxy). Being Open Source I guess you can nab their code. This would ensure easiest use of

QGIS when behind a proxy.

Associated revisions

Revision c6a77f62 - 2015-01-21 01:01 AM - Larry Shaffer

Fix #6922, rearrange proxy form to clearly show when system's is used

History

#1 - 2013-10-15 06:32 AM - Jonathan Moules

The OSGeo4W installer has this as an option too under "Use IE5 Settings".

#2 - 2014-10-28 03:34 PM - Larry Shaffer

- File qgis-proxy-mockup.png added

After looking over the QGIS proxy factory code, and the Qt documentation, it looks like QGIS may already support your system proxy setup.

Try the following settings under Options->Network:

    -  Check Use proxy for web access

    -  Make sure the Proxy type is set to DefaultProxy

    -  Make sure all other settings are cleared under Use proxy for web access (excepting your Exclude URLs list, if using that)

Then, test whether your system proxy configuration is being used.

Here is what should be happening under those circumstances:

    -  DefaultProxy type is mapped to informing the QGIS custom network access manager to use the system's defined proxy, which is exactly what you are

looking to do.

    -  If it can not find a proxy set up there, it should drop back to using Internet Explorer's setup, which is also what you are looking for.

This is described in the QNetworkProxyFactory::systemProxyForQuery() documentation.

DefaultProxy was also not noted as querying the system proxy setting(s) in the official QGIS docs either.
https://github.com/qgis/QGIS/blob/master/src/core/qgsnetworkaccessmanager.cpp#L283-L293
http://qt-project.org/doc/qt-4.8/qnetworkproxyfactory.html#systemProxyForQuery
http://docs.qgis.org/2.2/en/docs/user_manual/introduction/qgis_configuration.html#network-menu


The DefaultProxy option in the popup combobox is also a bit misleading, in that once set, all other settings (other than Exclude URLs) are ignored, if a

proxy is returned from querying the system. The dialog should really have its layout updated to be Use system proxy OR Use configured proxy, then

list the Excluded URLs below that.

The QNetworkProxy::DefaultProxy type refers to using the defined application proxy, whereas there should be a separate option for using the system proxy

settings. As is stand right now (2.5 dev), once the proxy settings are saved, and DefaultProxy is set for proxy type, then on next launch, that triggers the

code to check for a system proxy, and if one is returned, then the other manual proxy settings will be ignored. That is a bug. Using the system proxy

settings should be a separate option from defining the proxy type.

Attached is a mockup of what I think that dialog should look like. Note: it also includes a mockup for the option of .pac file support (unimplemented).

#3 - 2014-10-28 03:40 PM - Larry Shaffer

- Target version set to Future Release - Lower Priority

- Assignee set to Jürgen Fischer

- Category set to Network

Hi Jürgen. I have assigned you, to review whether my assessment here is correct (or not). I can do the coding ASAP to fix this for 2.6 (though it would add

a few GUI strings to that dialog).

#4 - 2015-01-20 04:03 PM - Larry Shaffer

- Status changed from Open to Closed

Fixed in changeset commit:"c6a77f62012d2626e2502afb7edd0b3c6a9ed886".
